=begin Copyright 2009, Chris Glasier

# Release 1.0 - Basic configuration

#Release 1.01 - Revisions
# 	Added sketchup.rb (thanks to Tomasz SCF)
#	Add new scene setup for new files
#	Rename layer

#Release 1.04

#	skp functions renamed according to DeviceNameAction (DNA!) - e.g. sceneLayersAdd



GUIDELINES FOR SCENE MANAGEMENT

Use cgScene's

left tumbler to browse (1st click) and open (2nd click) scene and current aspect (e.g layer)
middle tumbler to check each aspect of the current scene
middle tumbler layer menu to sort layers by abc or visibility and to add and name new layer
middle tumbler components menu to show or hide all current scene components 
right tumbler to browse (1st click) and hide/show (2nd click) properties to save, layers and components, and change (2nd click) views and styles.

Click Update to save scene properties selected. Update before Synch.

Click Synch to update web dialog content after making changes or component selection in Sketchup display.

Use Sketchup's

context menu to add, delete, rename or describe a scene
layer window to rename or delete existing layer
layer window to select layer colors
shadows toolbar


If a scene is not showing what is expected double check properties to ensure evrything required is saved and check layer and components status as these can contradict each other. If still not performing correctly email chrisglasier@gmail.com

Record codes

typeCodes = "0 Collection, 1 Grouping, 2 Component, 3 Dimension, 4 Label, 5 scene"

coreCodes ="0 Entry no, 1 genericName, 2 givenName, 3 childNos, 4 parentNo, 5 visiblility, 6 typeCode, 7 status,8 user, 9 removed date,10 parent of removed"

positionCodes = "X,Y,Z,Rotation x,Rotation y,Rotation z,Width,Depth,Height"

fileCodes = "File,Width,Depth,Height"

inputCodes = "Input width,Input depth,Input height,Input area"

timeCodes = "Start month,Start date,Start year,Duration"

productCodes = "Supplier,Product reference,Delivery,Price,Purchase order no, Purchase order date"

Thanks to RickW edit - http://forums.sketchucation.com/viewtopic.php?f=180&t=21131&p=177724#p177724. 
=end

require 'sketchup.rb'

class MySelectionObserver < Sketchup::SelectionObserver
def onSelectionBulkChange(selection)
  model = Sketchup.active_model
  selection = model.selection
  $chrisglasierScenes.selected = selection[0].name  #CG# does this need to be global - only used here #RW# Yes, it references $chrisglasierScenes, which is set in your next code block - it is used to create a single instance of your class.
  puts $chrisglasierScenes.selected
  cmd = "sceneTest('#{selected}');"
  $chrisglasierScenes.dlg.execute_script(cmd)   #CG#don't really understand why this can be attached to a global! #RW# the global references an instance of your class.  Conceptually, it's really no different than "model = Sketchup.active_model".  Perhaps the confusing part is that the global is defined near the end of the code, but referenced earlier in code blocks.  It has to be set at the end; otherwise, it will return an error because the class it wants to be an instance of is not yet undefined.
end  # def
end  # class


class ChrisGlasierScenes # CREATE A NEW CLASS

attr_accessor :dialog, :selected # PROVIDES ACCESS TO THESE VARIABLES FROM OUTSIDE THE INSTANCE

@@observer_added = false # A CLASS VARIABLE

def initialize # THE AUTOMATIC METHOD CALLED WHEN A NEW INSTANCE OF THE CLASS IS CREATED
  @model = Sketchup.active_model
  unless @@observer_added # IF THIS IS 'FALSE', THEN YOUR OBSERVER HAS NOT BEEN ADDED YET
   Sketchup.active_model.selection.add_observer(MySelectionObserver.new)
   @@observer_added = true # SET TO 'TRUE' SO NO ADDITIONAL OBSERVERS ARE ADDED  
   end
end   #cg# I ended initialize here - is that correct? #RW# yes

###def ChrisGlasierScenes.cgScenes #CG# I added this - is it correct? #RW# it depends.  If you want to call the method without an instance, yes.  Since $chrisglasierScenes is created as an instance, it is not necessary - you can use "def cgScenes"

def cgScenes
  Sketchup.send_action "selectSelectionTool:"
 
 @dlg = UI::WebDialog.new("cgScenes02", true, "Scene machine", 300, 205, 0, 0, true)
 
 subDir = "chrisGlasierScenes02PC/"
  fileName = "scene machine.htm"
  @dlg.set_file File.join(File.dirname(__FILE__), subDir+fileName)
  
  
@dlg.add_action_callback("coreSet_size") {|d, p|
	
a = p.split(",")
w = Integer(a[0])
h = Integer(a[1])
@dlg.set_size w,h   }




########## DICTIONARIES ##########


@dlg.add_action_callback("sceneReformDictCheck") {|d, p|

model = Sketchup.active_model

if model.attribute_dictionaries["master"]==nil

dic = 0

else

dic = 1

end

puts dic

cmd = "sceneReformDictCheckReceive('#{dic}');"
@dlg.execute_script (cmd)  				}



@dlg.add_action_callback("sceneReformDictSet") {|d, p|

model = Sketchup.active_model
entities = model.entities
layers = model.layers
scenes = model.pages



create_if_nil = true

comDic = model.attribute_dictionary "component",create_if_nil

layDic = model.attribute_dictionary "layer",create_if_nil

sceDic = model.attribute_dictionary "scene",create_if_nil

puts comDic.values.size

if comDic.values.size == 0

ea = []
nr = 0

entities.each do | e |

if  e.class == Sketchup::Group || e.class == Sketchup::ComponentInstance


if  e.class == Sketchup::Group
name = e.name

if name == ""
name = "Group"
end

end		#group name

if e.class == Sketchup::ComponentInstance
name = e.definition.name



end		#comp name

e.name = name+"qq"+nr.to_s		#to cross id with javascript

parent = e.layer.name 


string = []
string.push [0,nr].join(",")			#unique id
string.push [1,name].join(",")			#generic name
string.push [4,parent].join(",")		#parent id										


ea.push(string.join(","))

nr+=1

end		#g or c
end		#loop


comDic[0] = ea.join(",")


##### All Layers

la = []

layers.each do | l |

la.push(l.name)

end

layDic[0] = la.join(",")


##### Scenes

sa = []
a = 0

scenes.each do | s |

sa[a] = []

sa[a][0] = [0,s.name]



#non visible layers

slayers = s.layers

slayers.each do | sl |

sa[a].push([1,sl.name])

end

sa[a] = sa[a].join(",")

a+=1

end

sceDic[0] = sa.join(",")

end		#comp size == 0


array = [comDic[0],layDic[0],sceDic[0]]

array = array.join(";")

#puts array

cmd = "sceneReformDictReceive('#{array}');"
d.execute_script (cmd)  }





###SAVE

@dlg.add_action_callback("sceneTreeStringSave") {|d, p|

v = d.get_element_value("box")

model = Sketchup.active_model

create_if_nil = true

masterDic = model.attribute_dictionary "master",create_if_nil

masterDic[0] = v

puts masterDic[0]   }





########## ALL CONVERSIONS ##########


#Exposes any top level group that includes one or more components and other groups


@dlg.add_action_callback("sceneReformCollective") {|d, p|
	
model = Sketchup.active_model
layers = model.layers

# All layers visible

layers.each do |layer|

layer.visible = true

end

#Hides all entities

entities = model.entities

array = []

a = 0

entities.each do |entity|


#Hides everything

entity.hidden = true

# examines sub entities for groups and components

if  entity.class == Sketchup::Group 

#puts "Entity " +entity.typename.to_s

ents = entity.entities

gc = 0

ents.each do |ent|

if  ent.class == Sketchup::Group || ent.class == Sketchup::ComponentInstance 

#puts "ent " +ent.typename.to_s

gc = gc + 1

end
end

#exposes group

if gc > 0

entity.hidden = false

end
end
end 

  }





#Exposes all loose geometry




@dlg.add_action_callback("sceneReformGeometry") {|d, p|
	
model = Sketchup.active_model
layers = model.layers
entities = model.entities

#Unhides the layers

layers.each do |layer|

layer.visible = true

end

#Hides everything not edge or face

entities.each do |entity|

if  entity.class == Sketchup::Face || entity.class == Sketchup::Edge 

entity.hidden = false 

else

entity.hidden = true 

end
end   }





#Lists layers


@dlg.add_action_callback("sceneReformLayers") {|d, p|

model = Sketchup.active_model
layers = model.layers

array = []


layers.each do |layer|

array.push layer.name

end  

array = array.join(",")

#puts array

cmd = "sceneReformLayersReceive('#{array}');"
@dlg.execute_script (cmd)   }



########## SCENES ##########


@dlg.add_action_callback("sceneCount") {|d, p|
	
model = Sketchup.active_model
pages = model.pages
count = pages.count

cmd = "receiveSceneCount('#{count}');"
p cmd
@dlg.execute_script (cmd)   }


##### SCENE ADD

@dlg.add_action_callback("sceneScenesAdd") {|d, p|

model = Sketchup.active_model
pages = model.pages
pages.add p   }


##### OPENING SCENE
	

@dlg.add_action_callback("sceneScenesFirst") {|d, p|
	
model = Sketchup.active_model
pages = model.pages

a=0

pages.each do | page |
		
if page == pages.selected_page

puts page.name

array =[$Selected,a]
array = array.join(",")
$Selected = "Nil"

cmd = "receiveFirstScene('#{array}');"
@dlg.execute_script (cmd)
end
a += 1
end     }


##### SCENE LIST
	
	
@dlg.add_action_callback("sceneScenesFind") {|d, p|
	
model = Sketchup.active_model
pages = model.pages
	
a = 0
array = []

pages.each do | page |

array[a] = []
array[a][0] = page.name
array[a][1] = a
array[a] = array[a].join(",")
a+=1

end  #loop

array = array.join(";")

cmd = "receiveScenes('#{array}');"
@dlg.execute_script (cmd)  	}







##### GOTO SCENE

	
@dlg.add_action_callback("sceneSceneSelected") {|d, p|
	
a = p.split(",")
	
ind = Integer(a[0])
	
model = Sketchup.active_model
pages = model.pages
pages.selected_page = pages[ind]
puts pages[ind].name

	 	}
	
	
	
##### GET SCENE STYLE
	
	
@dlg.add_action_callback("sceneScenesStyle") {|d, p|
	
model = Sketchup.active_model
pages = model.pages
name = pages.selected_page.style.name

cmd = "receiveSceneStyle('#{name}');"
@dlg.execute_script (cmd)	 	}



########## PROPERTIES (to save) ##########

##### PROPERTY LIST

@dlg.add_action_callback("scenePropertiesFind") {|d, p|
	
model = Sketchup.active_model
page = model.pages.selected_page
	
array = []
array.push ["Axes",page.use_axes?].join(",")
array.push ["Camera",page.use_camera?].join(",")
array.push ["Hidden",page.use_hidden?].join(",")
array.push ["Hidden layers",page.use_hidden_layers?].join(",")
array.push ["Rendering options",page.use_rendering_options?].join(",")
array.push ["Section planes",page.use_section_planes?].join(",")
array.push ["Shadow info",page.use_shadow_info?].join(",")
array.push ["Style",page.use_style?].join(",")

array = array.join(";")

cmd = "receiveProperties('#{array}');"
@dlg.execute_script (cmd)  	}


##### PROPERTY TOGGLES ON/OFF

@dlg.add_action_callback("scenePropertyToggleAxeson") {|d, p|
model = Sketchup.active_model
page = model.pages.selected_page
page.use_axes = false   }

@dlg.add_action_callback("scenePropertyToggleAxesoff") {|d, p|
model = Sketchup.active_model
page = model.pages.selected_page
page.use_axes = true    }
	
@dlg.add_action_callback("scenePropertyToggleCameraon") {|d, p|
model = Sketchup.active_model
page = model.pages.selected_page
page.use_camera = false    }

@dlg.add_action_callback("scenePropertyToggleCameraoff") {|d, p|
model = Sketchup.active_model
page = model.pages.selected_page
page.use_camera = true    }

@dlg.add_action_callback("scenePropertyToggleHiddenon") {|d, p|
model = Sketchup.active_model
page = model.pages.selected_page
page.use_hidden = false    }

@dlg.add_action_callback("scenePropertyToggleHiddenoff") {|d, p|
model = Sketchup.active_model
page = model.pages.selected_page
page.use_hidden = true    }

@dlg.add_action_callback("scenePropertyToggleHidden_layerson") {|d, p|
model = Sketchup.active_model
page = model.pages.selected_page
page.use_hidden_layers = false    }

@dlg.add_action_callback("scenePropertyToggleHidden_layersoff") {|d, p|
model = Sketchup.active_model
page = model.pages.selected_page
page.use_hidden_layers = true    }

@dlg.add_action_callback("scenePropertyToggleRendering_optionson") {|d, p|
model = Sketchup.active_model
page = model.pages.selected_page
page.use_rendering_options = false    }

@dlg.add_action_callback("scenePropertyTogglerendering_optionsoff") {|d, p|
model = Sketchup.active_model
page = model.pages.selected_page
page.use_rendering_options = true    }

@dlg.add_action_callback("scenePropertyToggleSection_planeson") {|d, p|
model = Sketchup.active_model
page = model.pages.selected_page
page.use_section_planes = false    }

@dlg.add_action_callback("scenePropertyToggleSection_planesoff") {|d, p|
model = Sketchup.active_model
page = model.pages.selected_page
page.use_section_planes = true    }

@dlg.add_action_callback("scenePropertyToggleShadow_infoon") {|d, p|
model = Sketchup.active_model
page = model.pages.selected_page
page.use_shadow_info = false    }

@dlg.add_action_callback("scenePropertyToggleShadow_infooff") {|d, p|
model = Sketchup.active_model
page = model.pages.selected_page
page.use_shadow_info = true    }

@dlg.add_action_callback("scenePropertyToggleStyleon") {|d, p|
model = Sketchup.active_model
page = model.pages.selected_page
page.use_style = false    }

@dlg.add_action_callback("scenePropertyToggleStyleoff") {|d, p|
model = Sketchup.active_model
page = model.pages.selected_page
page.use_style = true    }


########## LAYERS ##########


##### LAYERS LIST	
	
		
@dlg.add_action_callback("sceneLayersFind") {|d, p|
	
model = Sketchup.active_model
layers = model.layers
	
a = 0
b=-1
array = []

layers.each do |layer|
b += 1
array[a] = []
array[a][0] = layer.name
array[a][1] = layer.visible?
array[a][2] = b
array[a] = array[a].join(",")
a+=1

end  #loop

array = array.join(";")

cmd = "receiveLayers('#{array}');"
@dlg.execute_script (cmd)  	}


##### LAYER ADD


@dlg.add_action_callback("sceneLayersAdd") {|d, p|

model = Sketchup.active_model
layers = model.layers
layers.add "Aa"  }


##### LAYER TOGGLE ON/OFF


@dlg.add_action_callback("sceneLayerToggleon") {|d, p|
a= p.split(",")

ind = Integer(a[0])

model = Sketchup.active_model
layer = model.layers[ind]
layer.visible = false    }


@dlg.add_action_callback("sceneLayerToggleoff") {|d, p|
a= p.split(",")

ind = Integer(a[0])

model = Sketchup.active_model
layer = model.layers[ind]
layer.visible = true    }


##### LAYER RENAME


@dlg.add_action_callback("sceneLayersRename") {|d, p|

a = p.split(",")

newName = a[0].to_str

model = Sketchup.active_model
ind = model.layers.length-1

layer = model.layers[ind]
layer.name = newName 

   }







########## COMPONENTS (outliner) ##########


##### COMPONENT LIST


@dlg.add_action_callback("sceneComponentsFind") {|d, p|
	
model = Sketchup.active_model
entities = model.active_entities

a = 0
b = -1
array = []

entities.each do |entity|
b += 1

if  entity.class == Sketchup::Group || entity.class == Sketchup::ComponentInstance 

#if  entity.class == Sketchup::ComponentInstance 

if entity.layer.visible?

array[a] = []


if  entity.class == Sketchup::ComponentInstance 

array[a][0] = entity.definition.name

end

if  entity.class == Sketchup::Group

if entity.name == '' 

array[a][0] = "Group"  #entity.name

else 

array[a][0] = entity.name

end
end  # if group

array[a][1] = entity.hidden?

array[a][2] = b #index in entity array for hiliting

array[a] = array[a].join(",")

a+=1

end  # if class
end  # if visible
end  # loop

array = array.join(";")


cmd = "receiveComponents('#{array}');"
@dlg.execute_script (cmd)      }




##### COMPONENT SHOW/HIDE ALL




@dlg.add_action_callback("sceneComponentsToggleAll") {|d, p|

p = p.to_s
	
model = Sketchup.active_model
entities = model.active_entities

entities.each do |entity|

if  entity.class == Sketchup::Group || entity.class == Sketchup::ComponentInstance 

if entity.layer.visible?

entity.hidden = false if p == "Show"

entity.hidden = true if p == "Hide"

end
end
end   }








##### COMPONENT BOUNDING BOX

		            
@dlg.add_action_callback("sceneHiliteOn") {|d, p|
 entityNo =  Integer(p)
	
model = Sketchup.active_model
entities = model.active_entities
entity = entities[entityNo]
selection = model.selection
selection.add entity   }
	
	
@dlg.add_action_callback("sceneHiliteClear") {|d, p|
	 	
model = Sketchup.active_model
selection = model.selection
selection.clear   }


##### COMPONENT TOGGLE ON/OFF
	
	
@dlg.add_action_callback("sceneComponentToggleoff") {|d, p|
a= p.split(",")

ind = Integer(a[0])

model = Sketchup.active_model
entity = model.entities[ind]
entity.hidden = false    }

@dlg.add_action_callback("sceneComponentToggleon") {|d, p|
a= p.split(",")

ind = Integer(a[0])

model = Sketchup.active_model
entity = model.entities[ind]
entity.hidden =  true    }


########## STYLES


##### STYLE LIST	


@dlg.add_action_callback("sceneStylesFind") {|d, p|
	
model = Sketchup.active_model
styles = model.styles
	
a = 0
array = []

styles.each do |style|

array[a] = []
array[a][0] = style.name
array[a][1] = a
	
array[a] = array[a].join(",")
	
a+=1

end  #loop

array = array.join(";")
	
cmd = "receiveStyles('#{array}');"
@dlg.execute_script (cmd)  	}


##### SET STYLE
		
	
@dlg.add_action_callback("sceneStyleUse") {|d, p|
	
a=p.split(",")
	
cind = Integer(a[0])
	
model = Sketchup.active_model
styles = model.styles
style = styles[cind]
		
styles.selected_style = style 	}
	

########## CAMERA VIEWS

      
@dlg.add_action_callback("sceneViewTop") {|d, p|
Sketchup.send_action("viewTop:")  }
	
@dlg.add_action_callback("sceneViewBottom") {|d, p|
Sketchup.send_action("viewBottom:")  }
	
@dlg.add_action_callback("sceneViewFront") {|d, p|
Sketchup.send_action("viewFront:")  }
	
@dlg.add_action_callback("sceneViewBack") {|d, p|
Sketchup.send_action("viewBack:")  }
	
@dlg.add_action_callback("sceneViewLeft") {|d, p|
Sketchup.send_action("viewLeft:")  }
	
@dlg.add_action_callback("sceneViewRight") {|d, p|
Sketchup.send_action("viewRight:")  }
	
@dlg.add_action_callback("sceneViewIsometric") {|d, p|
Sketchup.send_action("viewIso:")  }
	
@dlg.add_action_callback("sceneViewPerspective") {|d, p|
Sketchup.send_action("viewPerspective:")  }
	
@dlg.add_action_callback("sceneViewZoomExtents") {|d, p|
Sketchup.send_action("viewZoomExtents:")  }

		

########## SCENE UPDATE


@dlg.add_action_callback("sceneUpdate") {|d, p|

model = Sketchup.active_model
page = model.pages.selected_page

page.update   }	

@dlg.show()

end #cgScenes
end #class ChrisGlasierScenes

$chrisglasierScenes = $chrisglasierScenes || ChrisGlasierScenes.new # SETS THE GLOBAL TO A NEW INSTANCE OF YOUR CLASS, UNLESS IT HAS ALREADY BEEN SET - SAVES OVERHEAD WHEN RELOADING THE .RB FILE
#CG# changed different spellings and capitalisation in mock up

unless file_loaded?("chrisglasierScenes02PC.rb")
  file_loaded("chrisglasierScenes02PC.rb")
  ($submenu) ? (submenu = $submenu) : (submenu = UI.menu("Plugins"))
  submenu.add_item("cgScenes02" ){ $chrisglasierScenes.cgScenes }
end #RW# edited to be compatible with Organizer :) and to not repeat the "file_loaded" call when reloading.